-- Version : English
-- Last Update : 02/17/2005

-- Cosmos Configuration
COMBATSTATS_CONFIG_HEADER		= "CombatStats";
COMBATSTATS_CONFIG_HEADER_INFO		= "These options modify CombatStats.\n ";
COMBATSTATS_CONFIG_ONOFF		= "Turn CombatStats On/Off";
COMBATSTATS_CONFIG_ONOFF_INFO		= "If this box is unchecked,\n CombatStats is off.";
COMBATSTATS_CHAT_COMMAND_INFO		= "Tracks CombatStats and generates data.";
COMBATSTATS_CONFIG_HIDEONNOTARGET	= "Hide When No Target";
COMBATSTATS_CONFIG_HIDEONNOTARGET_INFO	= "If enabled then Combat Stats will only be visible when there is a target.";
COMBATSTATS_CONFIG_USEMOUSEOVER		= "Show CombatStats on mouseover";
COMBATSTATS_CONFIG_USEMOUSEOVER_INFO	= "If enabled, Combat Stats will appear when you mouseover the title.\nIf disabled, Combat Stats will appear when you click on the title."

COMBATSTATS_CONFIG_DPS_LENGTH		= "DPS Time Monitor Length";
COMBATSTATS_CONFIG_DPS_LENGTH_INFO	= "This is how many previous seconds to average your DPS over. (-1 to go for session)";
COMBATSTATS_CONFIG_DPS_LENGTH_TEXT	= "Length";
COMBATSTATS_CONFIG_DPS_LENGTH_APPEND	= " sec.";

-- Chat Configuration
COMBSTATS_CHAT_COMMAND_RESET		= "Reset combat stats data.";
CS_CHAT_COMMAND_INFO			= "Type /cs or /combatstats for usage instructions.";

-- Interface Configuration
DPS_DISPLAY				= "Overall DPS :: %.2f";
DPS_DISPLAY_INITIAL			= "Overall DPS :: ---";
CS_FRAME_GEN_ATTACK_NAME		= "Attack Name :";
CS_FRAME_TICKS_TEXT			= "DOT ticks.";
CS_FRAME_HITS_TEXT			= "hits out of";
CS_FRAME_SWINGS_TEXT			= "swings or uses.";
CS_FRAME_MISSES_TEXT			= "Misses : ";
CS_FRAME_DODGES_TEXT			= "Dodges : ";
CS_FRAME_PARRIES_TEXT			= "Parries : ";
CS_FRAME_BLOCKS_TEXT			= "Blocks : ";
CS_FRAME_RESISTS_TEXT			= "Resists : ";
CS_FRAME_IMMUNE_TEXT			= "Immune : ";
CS_FRAME_EVADES_TEXT			= "Evades : ";
CS_FRAME_DEFLECTS_TEXT			= "Deflects : ";
CS_FRAME_PERCENT_OVERALL_TEXT		= "Percentage of overall damage : ";
CS_FRAME_TIME_LASTCRIT_TEXT		= "Time since last crit : ";
CS_FRAME_TOTAL_TEXT			= "Total : ";
CS_FRAME_DAMAGE_TEXT			= "Damage : ";
CS_FRAME_MINMAX_TEXT			= "Min / Max : ";
CS_FRAME_AVGDMG_TEXT			= "Avg. Damage : ";
CS_FRAME_PERCENTDMG_TEXT		= "% Of Dmg. : ";

CS_DROPDOWN_SELECT_TEXT			= "Select Attack";

CS_TT_OVERALLPCT_TEXT			= "Overall critical hit percentage.";
CS_TT_OVERALLDMGPCT_TEXT		= "Percentage of the total damage done by all attacks that was done by this attack.";
CS_TT_NONCRIT_HITSPCT_TEXT		= "Percent of this attacks hits that are non critical hits.";
CS_TT_CRIT_HITSPCT_TEXT			= "Percent of this attacks hits that are critical hits.";
CS_TT_NONCRIT_DMGPCT_TEXT		= "Percentage of this attacks damage that was from non critical hits.";
CS_TT_CRIT_DMGPCT_TEXT			= "Percentage of this attacks damage that was from critical hits.";

CS_TEXT_RESET				= "Reset";
CS_TEXT_NA				= "N/A";
CS_TEXT_GENERAL				= "General Attack Info";
CS_TEXT_NONCRIT				= "Non-Crit Stats";
CS_TEXT_CRIT				= "Crit Stats";

CS_TEXT_ATTACK_DEFAULT			= "Default";
CS_TEXT_ATTACK_TOTAL			= "Total";

CLOCK_TIME_DAY				= "%d day";
CLOCK_TIME_DAYS      			= "%d days";
CLOCK_TIME_HOUR				= "%d hour";
CLOCK_TIME_HOURS     			= "%d hours";
CLOCK_TIME_MINUTE			= "%d minute";
CLOCK_TIME_MINUTES   			= "%d minutes";
CLOCK_TIME_SECOND			= "%d second";
CLOCK_TIME_SECONDS   			= "%d seconds";  

-- Localisation Strings
--  --------------------------------
--  HOWTO: localize Combat messages
--  --------------------------------
--  1) localize the regular expression for the combat chat message 
--     for each type of attack in the "match" field 
--  2) give the order of arguments as it appears in the chat message
--     in the "args" field. 
--     Valid entries are:
--     - CS_ARG_CREATURE
--     - CS_ARG_DAMAGE 
--     - CS_ARG_DAMAGETYPE
--     - CS_ARG_SPELL 
--     - CS_ARG_PET
--     
--     Note: There must be a corresponding arg entry for each group
--           in the regular expression. Don't give more or less args
--           than there are groups in the expression (will cause an 
--           error)
--     
--  Do _NOT_ change the name of the attack ;)

CS_MSG_XP_GAIN		= "(.+) dies, you gain (%d+) experience.";
CS_MSG_SLAIN_YOU	= "(.+) has slain you.";

-- non localised strings
-- DO NOT TRANSLATE OR CHANGE
RED_FONT_COLOR_CODE		= "|cffff2020";
NORMAL_FONT_COLOR_CODE	= "|cffffd200";
WHITE_FONT_COLOR_CODE	= "|cffffffff";
GREEN_FONT_COLOR_CODE	= "|cff20ff20";
BLUE_FONT_COLOR_CODE	= "|cff2020ff";

-- if these are NOT defined prior to creating arrays using them, their values will be NIL.
-- LEAVE THEM WHERE THEY ARE!
--  /grumpy sarf
CS_ARG_CREATURE 	= 1;
CS_ARG_DAMAGE	 	= 2;
CS_ARG_DAMAGETYPE	= 3;
CS_ARG_SPELL		= 4;
CS_ARG_PET			= 5;


CombatStats_ChatMessages = {
	default = {
		player = {
			hit = {
				match = "You hit (.+) for (%d+)%.";
				args = {CS_ARG_CREATURE, CS_ARG_DAMAGE};
			};
			crit  = {
				match = "You crit (.+) for (%d+)%.";
				args = {CS_ARG_CREATURE, CS_ARG_DAMAGE};
			};
			miss = {
				match = "You miss (.+)%.";
				args = {CS_ARG_CREATURE};
			};
			parry = {
				match = "You attack. (.+) parries%.";
				args = {CS_ARG_CREATURE};
			};
			evade = {
				match = "You attack. (.+) evades%.";
				args = {CS_ARG_CREATURE};
			};
			dodge = {
				match = "You attack. (.+) dodges%.";
				args = {CS_ARG_CREATURE};
			};
			deflect = {
				match = "You attack. (.+) deflects%.";
				args = {CS_ARG_CREATURE};
			};
			block = {
				match = "You attack. (.+) blocks%.";
				args = {CS_ARG_CREATURE};
			};
		};
		pet = {
			hit = {
				match = "(.+) hits (.+) for (%d+).";
				args = {CS_ARG_PET, CS_ARG_CREATURE};
			};
			crit = {
				match = "(.+) crits (.+) for (%d+).";
				args = {CS_ARG_PET, CS_ARG_CREATURE};
			};
			miss = {
				match = "(.+) misses (.+)%.";
				args = {CS_ARG_PET, CS_ARG_CREATURE};
			};
			parry = {
				match = "(.+) attacks. (.+) parries.";
				args = {CS_ARG_PET, CS_ARG_CREATURE};
			};
			evade = {
				match = "(.+) attacks. (.+) evades.";
				args = {CS_ARG_PET, CS_ARG_CREATURE};
			};
			dodge = {
				match = "(.+) attacks. (.+) dodges.";
				args = {CS_ARG_PET, CS_ARG_CREATURE};
			};
			deflect = {
				match = "(.+) attacks. (.+) deflects.";
				args = {CS_ARG_PET, CS_ARG_CREATURE};
			};
			block = {
				match = "(.+) attacks. (.+) blocks.";
				args = {CS_ARG_PET, CS_ARG_CREATURE};
			};
		}
	};
	spell = {
		player = {
			hit = {
				match = "Your (.+) hits (.+) for (%d+)%.";
				args = {CS_ARG_SPELL, CS_ARG_CREATURE, CS_ARG_DAMAGE};
			};
			crit = {
				match = "Your (.+) crits (.+) for (%d+)%.";
				args = {CS_ARG_SPELL, CS_ARG_CREATURE, CS_ARG_DAMAGE};
			};
			dot = {
				match = "(.+) suffers (%d+) (.+) damage from your (.+)%.";
				args = {CS_ARG_CREATURE, CS_ARG_DAMAGE, CS_ARG_DAMAGETYPE, CS_ARG_SPELL};
			};
			miss = {
				match = "Your (.+) missed (.+)%.";
				args = {CS_ARG_SPELL, CS_ARG_CREATURE};
			};
			parry = {
				match = "Your (.+) is parried by (.+)%.";
				args = {CS_ARG_SPELL, CS_ARG_CREATURE};
			};
			evade = {
				match = "Your (.+) was evaded by (.+)%.";
				args = {CS_ARG_SPELL, CS_ARG_CREATURE};
			};
			dodge = {
				match = "Your (.+) was dodged by (.+)%.";
				args = {CS_ARG_SPELL, CS_ARG_CREATURE};
			};
			deflect = {
				match = "Your (.+) was deflected by (.+)%.";
				args = {CS_ARG_SPELL, CS_ARG_CREATURE};
			};
			block = {
				match = "Your (.+) was blocked by (.+)%.";
				args = {CS_ARG_SPELL, CS_ARG_CREATURE};
			};
			resist = {
				match = "Your (.+) was resisted by (.+)%.";
				args = {CS_ARG_SPELL, CS_ARG_CREATURE};
			};
			immune = {
				match = "Your (.+) failed%. (.+) is immune%.";
				args = {CS_ARG_SPELL, CS_ARG_CREATURE};
			};
		};			
		pet = {
			hit = {
				match = "(.+)'s (.+) hits (.+) for (%d+)%.";
				args = {CS_ARG_PET, CS_ARG_SPELL, CS_ARG_CREATURE, CS_ARG_DAMAGE};
			};
			crit= {
				match = "(.+)'s (.+) crits (.+) for (%d+)%.";
				args = {CS_ARG_PET, CS_ARG_SPELL, CS_ARG_CREATURE, CS_ARG_DAMAGE};
			};
			miss = {
				match = "(.+)'s (.+) misses (.+).";
				args = {CS_ARG_PET, CS_ARG_SPELL, CS_ARG_CREATURE};
			};
			resist = {
				match = "(.+)'s (.+) was resisted by (.+).";
				args = {CS_ARG_PET, CS_ARG_SPELL, CS_ARG_CREATURE};
			};
			dot = {
				match = "(.+) suffers (%d+) (.+) damage from (.+)'s (.+)%.";
				args = {CS_ARG_CREATURE, CS_ARG_DAMAGE, CS_ARG_DAMAGETYPE, CS_ARG_PET, CS_ARG_SPELL};
			};
			parry = {
				match = "(.+)'s (.+) was parried by (.+).";		-- TODO: verify, but parrying spells should be impossible
				args = {CS_ARG_PET, CS_ARG_SPELL, CS_ARG_CREATURE};
			};
			dodge = {
				match = "(.+)'s (.+) was dodged by (.+).";
				args = {CS_ARG_PET, CS_ARG_SPELL, CS_ARG_CREATURE};
			};
			block = {
				match = "(.+)'s (.+) was blocked by (.+).";
				args = {CS_ARG_PET, CS_ARG_SPELL, CS_ARG_CREATURE};
			};
			evade = {
				match = "(.+)'s (.+) was evaded by (.+).";
				args = {CS_ARG_PET, CS_ARG_SPELL, CS_ARG_CREATURE};
			};
			deflect = {
				match = "(.+)'s (.+) was deflected by (.+).";
				args = {CS_ARG_PET, CS_ARG_SPELL, CS_ARG_CREATURE};
			};
			immune = {
				match = "(.+)'s (.+) failed. (.+) is immune.";
				args = {CS_ARG_PET, CS_ARG_SPELL, CS_ARG_CREATURE};
			};
		};
	};
};

